import { __rest } from "tslib";
import React, { useMemo, createContext, useContext } from 'react';
import { Analytics, AnalyticsBrowser, } from '@segment/analytics-next';
export var createClient = function (settings, options) { return AnalyticsBrowser.load(settings, options); };
var AnalyticsContext = createContext(null);
export var AnalyticsProvider = function (_a) {
    var children = _a.children, rest = __rest(_a, ["children"]);
    var client = useMemo(function () {
        if ('client' in rest) {
            return rest.client;
        }
        else {
            return AnalyticsBrowser.load(rest);
        }
    }, [rest]);
    if (!(client instanceof AnalyticsBrowser) || !(client instanceof Analytics)) {
        throw new Error('Invalid Segment `client`. Refer documentation for correct usage');
    }
    return (React.createElement(AnalyticsContext.Provider, { value: client }, children));
};
export var useAnalytics = function () {
    var analytics = useContext(AnalyticsContext);
    if (!(analytics instanceof AnalyticsBrowser)) {
        throw new Error('Analytics client not found. Make sure `AnalyticsProvider` is an ancestor of this component');
    }
    return analytics;
};
//# sourceMappingURL=index.js.map